<style>
html {
    background-color: #f6f6f6;
    margin: 16px;
}
body {
    color: #333;
    font-family: "Open Sans", "Helvetica Neue", "Segoe UI", Helvetica, Arial, sans-serif;
}
ul {
    padding-left: 1.2rem;
}
li { margin: 2px; }
h1 {
    font-size: 2.0rem;
    margin: 0;
}
h2 {
    color: #444;
    font-size: 1.4rem;
    margin: 1em 0 0.1em 0;
}
a {
    color: #000;
}
article { display: block; }
.release-date, .forum-link {
    font-size: 0.9rem;
    font-style: italic;
    color: #666;
}
</style>

<h1>Dev Channel Changelog</h1>

<article class="current">
<h2>Build 3175</h2>
<div class="release-date">12 May 2018</div>
<ul>
    <li>Misc crash fixes</li>
</ul>
</article>

<article>
<h2>Build 3174</h2>
<div class="release-date">11 May 2018</div>
<ul>
    <li>Fixed a spell check rendering regression in 3171</li>
</ul>
</article>

<article>
<h2>Build 3173</h2>
<div class="release-date">10 May 2018</div>
<ul>
    <li>Fixed a rendering regression in 3171</li>
</ul>
</article>

<article>
<h2>Build 3171</h2>
<div class="release-date">10 May 2018</div>
<ul>
    <li>Several high DPI related fixes</li>
    <li>Added <tt>ui_scale</tt> setting to scale the entire UI</li>
    <li>Various syntax highlighting improvements</li>
    <li>Linux: Added workaround for a display driver issue, giving significant scrolling improvements for some environments</li>
    <li>Indexing: Added more information in the <i>Indexing Status</i> window, and reduced CPU utilization in some scenarios</li>
    <li>Mac: Add default key bindings for <tt>ctrl+pgup</tt> and <tt>ctrl+pgdn</tt> to match Firefox</li>
    <li>Some crash fixes</li>
</ul>
</article>

<article>
<h2>Build 3169</h2>
<div class="release-date">5 May 2018</div>
<ul>
    <li>Linux: Candidate crash fix for an issue some users have been seeing</li>
</ul>
</article>

<article>
<h2>Build 3168</h2>
<div class="release-date">3 May 2018</div>
<ul>
    <li>Fix a command palette input history regression in 3167</li>
    <li>Windows: Tweaked label alignment</li>
</ul>
</article>

<article>
<h2>Build 3167</h2>
<div class="release-date">2 May 2018</div>
<ul>
    <li>Added support for 8k monitors and 300% DPI scale</li>
    <li>Themes can now provide @3x versions of images for very high DPI monitors</li>
    <li>Fixed a crash when adding folders to the sidebar with a complex combination of hardlinks and symlinks</li>
    <li>Mac: Fixed a crash regression in 3166</li>
</ul>
</article>

<article>
<h2>Build 3166</h2>
<div class="release-date">30 April 2018</div>
<ul>
    <li>Various syntax highlighting improvements</li>
    <li>Windows: Fixed a label eliding regression with fractional DPI scaling</li>
    <li>Fixed a scrolling regression in 3165</li>
    <li>Several crash fixes</li>
</ul>
</article>

<article>
<h2>Build 3165</h2>
<div class="release-date">27 April 2018</div>
<ul>
    <li>Windows: Improved support for fractional DPI scaling</li>
    <li>Mac: Fixed character spacing regression in 3163</li>
    <li>Linux: Improved behavior when <tt>fs.inotify.max_user_watches</tt> is too low</li>
    <li>Fixed hashed syntax highlighting getting confused by word wrapping</li>
    <li>Fixed popup and auto complete windows not showing when the caret is at the leftmost position of a widget</li>
</ul>
</article>

<article>
<h2>Build 3164</h2>
<div class="release-date">18 April 2018</div>
<ul>
    <li>Mac: Fixed a color glyph rendering regression in 3163</li>
    <li>API: Fixed a plugin loading regression in 3162</li>
</ul>
</article>

<article>
<h2>Build 3163</h2>
<div class="release-date">17 April 2018</div>
<ul>
    <li>Windows: Fix a performance regression in 3162</li>
    <li>Windows: Use GDI compatible text layout in some scenarios</li>
    <li>Mac: Tweaked character spacing to match 3143</li>
</ul>
</article>

<article>
<h2>Build 3162</h2>
<div class="release-date">16 April 2018</div>
<ul>
    <li>Added the Celeste color scheme to showcase hashed syntax highlighting</li>
    <li>More selection rendering improvements and fixes</li>
    <li>Fix a bug where theme animations may continue even after a layer has been hidden, causing excessive CPU usage</li>
    <li>Windows: improved DirectWrite anti-aliasing, adding support for system ClearType tuning</li>
    <li>Mac: Fixed sizing of some dialog windows when a theme uses a themed title bar</li>
    <li>Mac: Fixed <tt>font_options</tt> for OpenType features</li>
    <li>Mac: Fixed handling of color fonts with light color schemes</li>
    <li>Various syntax highlighting improvements</li>
    <li>API: Improve tracebacks for Python in <tt>.sublime-package</tt> files</li>
</ul>
</article>

<article>
<h2>Build 3161</h2>
<div class="release-date">4 April 2018</div>
<ul>
    <li>Improved selection rendering</li>
    <li>Fixed an auto complete rendering regression in 3158</li>
    <li>Reverted inbuilt Python to 3.3.6</li>
</ul>
</article>

<article>
<h2>Build 3160</h2>
<div class="release-date">30 March 2018</div>
<ul>
    <li>Fixed a crash regression in 3158 when using symlinks on Windows 7</li>
</ul>
</article>

<article>
<h2>Build 3159</h2>
<div class="release-date">29 March 2018</div>
<ul>
    <li>Fixed a crash regression in 3158</li>
    <li>Windows: Fixed a Build System regression with cmd based build systems</li>
</ul>
</article>

<article>
<h2>Build 3158</h2>
<div class="release-date">29 March 2018</div>
<ul>
    <li>Added support for Windows 10 (and 8.1) per-monitor DPI scaling</li>
    <li>Added Git Formats package for Git config files and use as <tt>core.editor</tt>, with thanks to <a href="https://github.com/y0ssar1an">Ryan Boehning</a> and <a href="https://github.com/deathaxe">deathaxe</a></li>
    <li>Added <tt>font_options</tt> for controlling ligatures and stylistic sets</li>
    <li>Added support for case-sensitive file systems on Macs</li>
    <li>File system notifications on Linux and Windows now account for symlinks (and Windows junctions)</li>
    <li>Linux file system notification now only requires a single inotify instance</li>
    <li>Improved handling of symlinks in the sidebar, including additions and removals</li>
    <li>Symlinks no longer have an expand arrow in the sidebar, but have a "Reveal Link Source" context menu entry</li>
    <li>Selections now render by default with true rounded corners</li>
    <li>Added color scheme options for selection border width, corner style and radius</li>
    <li>Selection background and border now support alpha channels</li>
    <li>Fixed a bug in where a phantom at the beginning of a line could cause syntax highlighting issues</li>
    <li>Tab width is now properly measured for proportional fonts</li>
    <li>Improved rendering and selection of emojis in the editor control</li>
    <li>Fixed some issues with loading fonts on Windows, including <tt>.fon</tt> fonts</li>
    <li>Fixed a crash on Macs when a window was closed and later the system switched GPUs</li>
    <li>Double-clicking a themed title bar on Mac now performs the default system action</li>
    <li>Reduced the number of file stats operations on Mac</li>
    <li>Context menus on Linux no long cause the editor control to be focused when closed</li>
    <li>Improved <tt>exec</tt> build target handling of killing child processes</li>
    <li>Add support for <tt>binary_file_patterns</tt>, <tt>index_exclude_patterns</tt> and <tt>index_include_patterns</tt> to <tt>.sublime-project</tt> files</li>
    <li><tt>index_exclude_patterns</tt> and <tt>index_include_patterns</tt> can now match full paths instead of just filename</li>
    <li>Fixed a bug on Linux where some ultra-wide ligatures would have the left edge clipped off</li>
    <li><tt>shell_environment</tt> is now ensured to be loaded before <tt>plugin_loaded()</tt> is called on plugins</li>
    <li>Fixed a bug where regions added through the API may not be properly applied when one of the regions ends at the beginning of the first line in the viewport</li>
    <li>Various syntax highlighting improvements</li>
    <li>API: Fix <tt>EventListener.on_activated_async()</tt> not being called for views when the editor starts</li>
    <li>API: Add <tt>ViewEventListener.on_activated()</tt> and <tt>ViewEventListener.on_activated_async()</tt> to be called for views when the editor starts</li>
    <li>API: The Python <tt>ssl</tt> module will now negotiate TLS 1.2, 1.1 or 1.0 with the `PROTOCOL_TLSv1` constant</li>
    <li>API: Updated Python to 3.3.7, SQLite to 3.22.0, and OpenSSL to 1.0.2n</li>
</ul>
</article>

<article>
<h2>Build 3157</h2>
<div class="release-date">9 February 2018</div>
<ul>
    <li>Fix a Command Palette regression in build 3156 with selecting previous filter text</li>
    <li>Solved increased CPU usage on Macs when a GPU switch occurs while using a theme with a colored title bar</li>
    <li>Fix <tt>embed</tt> action to work properly multiple times on a single line</li>
    <li>Correct a crash related to syntax highlighting when one of the contexts has a regex backreference in a pop pattern</li>
    <li>Command Palette keyboard shortcut hints are no longer cut off at 15 characters</li>
    <li>Fixed occasional yellow or black windows on Macs when using a theme with a colored title bar</li>
    <li>Various syntax highlighting improvements</li>
</ul>
</article>

<article>
<h2>Build 3156</h2>
<div class="release-date">2 December 2017</div>
<ul>
    <li><tt>embed</tt> action now treats the target as optional, rather than an error</li>
    <li>Various syntax definition errors now include the file name in the message</li>
    <li>Various syntax highlighting improvements</li>
    <li>Fix a crash in the Command Palette when using up and down keys with text input</li>
    <li>Initial Command Palette text is no longer selected</li>
    <li>Reinvoking the Command Palette while it is open, but without focus, now works properly</li>
    <li>API: Invoking a command that requires input from the Command Palette will always pass a dict to the input() method</li>
</ul>
</article>

<article>
<h2>Build 3155</h2>
<div class="release-date">30 November 2017</div>
<ul>
    <li>Various Command Palette improvements</li>
    <li>Syntax Highlighting: Fixed a bug with the handling of embed escape patterns</li>
    <li>Syntax Highlighting: Added stand alone syntax test runner</li>
    <li>API: Expanded ViewEventListener API</li>
    <li>API: Commands can implement <tt>input_description()</tt> to control how they're shown when accepting input in the Command Palette</li>
</ul>
</article>

<article>
<h2>Build 3154</h2>
<div class="release-date">11 November 2017</div>
<ul>
    <li>New Command Palette</li>
    <li>Fuzzy matching can match terms out of order by space separating them</li>
    <li>Added Arithmetic command to the Command Palette</li>
    <li>Added Rename File command to the Command Palette</li>
    <li>Added View Package File command to the Command Palette</li>
    <li>Added Convert Color Scheme command</li>
    <li>Various syntax highlighting improvements</li>
    <li>Fixed hashed syntax highlighting not working as expected with trailing whitespace</li>
    <li>Improve idle CPU usage</li>
    <li>Improved handling of invalid.deprecated scopes in default color schemes</li>
    <li>Add support for variables in escape patterns</li>
</ul>
</article>

<article>
<h2>Build 3153</h2>
<div class="release-date">1 November 2017</div>
<ul>
    <li>Syntax Highlighting: Add <tt>embed</tt> action to .sublime-syntax files, which can significantly reduce memory usage</li>
    <li>Add Hashed Syntax Highlighting</li>
    <li>Various syntax highlighting improvements</li>
    <li>Build systems: Improve cancellation handling</li>
    <li>Build systems: Use /usr/bin/env to locate bash</li>
    <li>Build systems: Fix multi-byte encodings sometimes triggering decoding errors</li>
    <li>Improved indent guide positions when using line padding</li>
    <li>Fixed gutter icons sometimes not drawing on macOS</li>
    <li>Fixed being unable to load dictionary files larger than 16mb</li>
    <li>Fix left arrow not working in the side bar</li>
    <li>Windows: Fix pen input</li>
    <li>Linux: Candidate fix for recent incompatibility with old Linux distributions</li>
    <li>API: Fix regions drawing with incorrect caret colors</li>
    <li>API: Loaded plugins are now stored in <tt>__plugins__</tt> rather than <tt>plugins</tt></li>
    <li>API: Plugin commands are now created before <tt>plugin_loaded()</tt> is run</li>
</ul>
</article>

<article>
<h2>Build 3152</h2>
<div class="release-date">20 October 2017</div>
<ul>
    <li>Added <tt>goto_reference</tt> command to the Goto menu</li>
    <li>Fixed not being able to grab the scrollbar by clicking on the rightmost pixels of the window</li>
    <li>Fixed a regression where visible whitespace wasn't drawn correctly in conjunction with code folding</li>
    <li>Fix double clicking on the selection not setting input focus when drag_drop is enabled</li>
    <li>Color Schemes can specify <tt>bold</tt> and <tt>italic</tt> in the brackets_options key</li>
    <li>Fix font_style typo when parsing <tt>.sublime-color-scheme</tt> files</li>
    <li><tt>.sublime-color-scheme</tt>: "defaults" has been renamed to "globals"</li>
    <li>Windows: Removed drop shadows due to Windows not handling them correctly</li>
    <li>API: Regions are able to change the foreground color again</li>
    <li>API: Improve <tt>View.find()</tt> and <tt>View.find_all()</tt> performance when doing literal matches</li>
</ul>
</article>

<article>
<h2>Build 3150</h2>
<div class="release-date">17 October 2017</div>
<ul>
    <li>Fixed double drawing of selected text</li>
    <li>Improved color scheme reloading</li>
    <li>Goto Symbol in Project shows only definitions, not references</li>
    <li>API: Added <tt>view.style()</tt></li>
</ul>
</article>

<article>
<h2>Build 3149</h2>
<div class="release-date">13 October 2017</div>
<ul>
    <li>Added new color scheme format, <tt>.sublime-color-scheme</tt></li>
    <li>Restore support for the <tt>selectionForeground</tt> color scheme key</li>
    <li><tt>selectionForeground</tt> can now be specified on a per-scope basis</li>
    <li>Added support for the <tt>invisibles</tt> key in color schemes</li>
    <li>Various syntax highlighting improvements</li>
    <li>Added <tt>Regex Replace Widget.sublime-settings</tt> and <tt>Console Input Widget.sublime-settings</tt></li>
    <li>Word wrap is turned on by default for the console</li>
    <li>Fixed word highlighting regression in 3148</li>
    <li>Mac: Fixed incorrect text rendering when LCD Font Smoothing is disabled</li>
    <li>Linux: Fixed underscores getting clipped in some fonts</li>
    <li>API: Added <tt>view.style_for_scope()</tt></li>
</ul>
</article>

<article>
<h2>Build 3148</h2>
<div class="release-date">10 October 2017</div>
<ul>
    <li>Various syntax highlighting improvements</li>
    <li>Selected text interacts properly with ligatures</li>
    <li>Color schemes no longer support the <tt>selectionForeground</tt> key</li>
    <li>Fixed text rendering regression that could result in clipped glyphs</li>
    <li>Windows and Linux: Improved High DPI minimap rendering</li>
    <li>Rulers are drawn with stippled lines</li>
    <li>Mac: Restore drop shadows</li>
    <li>Windows: Add drop shadows to popup windows</li>
    <li>Windows: Support gray_antialias in conjunction with DirectWrite</li>
    <li>API: Added automatically generated scope names for use with the regions API: <tt>region.redish</tt>, <tt>region.orangish</tt>, <tt>region.yellowish</tt>, <tt>region.greenish</tt>, <tt>region.bluish</tt>, <tt>region.purplish</tt> and <tt>region.pinkish</tt></li>
</ul>
</article>

<article>
<h2>Build 3147</h2>
<div class="release-date">6 October 2017</div>
<ul>
    <li>Fixed a regression in 3146 that caused incorrect punctuation rendering</li>
</ul>
</article>

<article>
<h2>Build 3146</h2>
<div class="release-date">6 October 2017</div>
<ul>
    <li>Added Goto References when hovering over a symbol</li>
    <li>Added ligature support for symbols</li>
    <li>Various syntax highlighting improvements, including significant improvements for Makefiles, with thanks to <a href="https://github.com/rwols">Raoul Wols</a></li>
    <li>Windows: DirectWrite is now used by default for all fonts</li>
</ul>
</article>

<article>
<h2>Build 3144</h2>
<div class="release-date">14 September 2017</div>
<ul>
    <li>Improved High DPI support</li>
    <li>Fixed an issue where out of memory conditions would trigger a buffer overflow instead of a clean crash</li>
</ul>
</article>

<article>
<h2>Build 3142</h2>
<div class="release-date">27 July 2017</div>
<ul>
    <li>Improved responsiveness when the system is under high CPU load</li>
    <li>Fixed flash-of-white that could occur when the auto complete window is closed</li>
    <li>Some minor HiDPI improvements under Windows and Linux</li>
    <li>Various syntax highlighting improvements</li>
    <li>Disable scroll animation when animation_enabled is false in settings</li>
    <li>API: Add View.text_to_window() and View.layout_to_window()</li>
</ul>
</article>

<article>
<h2>Build 3141</h2>
<div class="release-date">7 July 2017</div>
<ul>
    <li>Find settings, but not history, are now inherited by new windows</li>
    <li>Fixed a rare crash that could occur when dragging tabs</li>
</ul>
</article>

<article>
<h2>Build 3140</h2>
<div class="release-date">30 June 2017</div>
<ul>
    <li>Improved minihtml drawing performance in a couple of specific situations</li>
    <li>Fixed a regression from 3138 where build output panel would not automatically scroll to the end</li>
    <li>Backwards compatibility for sidebar icon opacity has been made more specific</li>
    <li>Windows: Fixed selection of Consolas Bold on Windows 7</li>
    <li>Mac: Resolved some edge cases with custom title bars and native fullscreen</li>
</ul>
</article>

<article>
<h2>Build 3139</h2>
<div class="release-date">20 June 2017</div>
<ul>
    <li>Fixed a New Window regression in 3138</li>
</ul>
</article>

<article>
<h2>Build 3138</h2>
<div class="release-date">20 June 2017</div>
<ul>
    <li>Various syntax highlighting improvements</li>
    <li>Fixed an issue with the console scroll area sticking to bottom</li>
    <li>Fixed an issue where multiple indexing status windows could be shown</li>
    <li>Added backwards compatibility for old themes that were seeing hidden sidebar icons</li>
    <li>Fixed some additional infrequently occurring crash bugs</li>
    <li>Fixed empty panes on startup when <tt>hot_exit</tt> was set to false</li>
    <li>Fixed an issue with incorrect row highlighting in the sidebar</li>
    <li>Linux: Update X11 selection on clipboard every time selection changes</li>
    <li>Windows: Further improvements to touch pad scrolling</li>
    <li>Windows: Improved file change detection robustness</li>
    <li>Windows: Improved font selection logic</li>
    <li>Windows: Fix ctrl+` shortcut for UK (ISO) keyboards</li>
    <li>Mac: Fix window shifting down when changing the color scheme while using the Adaptive theme</li>
    <li>API: Fixed a bug causing incorrect phantom contents</li>
</ul>
</article>

<article>
<h2>Build 3136</h2>
<div class="release-date">13 June 2017</div>
<ul>
    <li>Fixed a session restore regression in 3136 with large session files</li>
    <li>Windows: Improved touch pad scrolling</li>
    <li>Dragging a tab into a new window preserves the find history</li>
</ul>
</article>

<article>
<h2>Build 3135</h2>
<div class="release-date">12 June 2017</div>
<ul>
    <li>Fixed some infrequently occurring crash bugs</li>
    <li>New windows start with an empty find history</li>
    <li>Mac: <tt>show_navigation_bar</tt> now defaults to true</li>
</ul>
</article>

<article>
<h2>Build 3134</h2>
<div class="release-date">9 June 2017</div>
<ul>
    <li>Various syntax highlighting improvements</li>
    <li>Fixed a gutter rendering regression in 3133</li>
    <li>minihtml: Fixed a crash triggered by bad image paths</li>
    <li>Linux: Improved <tt>MOD3</tt> modifier key handling</li>
    <li>API: Fixed regression in window.set_view_index()</li>
</ul>
</article>

<article>
<h2>Build 3133</h2>
<div class="release-date">2 June 2017</div>
<ul>
    <li>Fixed a visible whitespace regression in 3132</li>
    <li>Fixed a multiple selection paste regression in 3132</li>
    <li>Mac: Handle layout changes due to macOS Sierra tabs</li>
    <li>Mac: Improved default web browser detection</li>
    <li>Find in Files panel now responds to <tt>find_all</tt> and <tt>replace_all</tt> commands</li>
    <li>Improved rendering performance with a large number of gutter icons</li>
    <li>Tweaked auto complete colors</li>
    <li>Fixed fold markers not properly respecting line padding</li>
    <li>Files can now be renamed when only the case has changed</li>
    <li>Legacy color schemes are back, but hidden</li>
    <li>minihtml: Fixed layout of html popups on Windows and Linux under HiDPI</li>
    <li>minihtml: Fixed crash when doctype is present</li>
    <li>API: Fixed input panel not running on_cancel when re-showing the input panel</li>
    <li>API: Fixed crash in window.set_view_index()</li>
</ul>
</article>

<article>
<h2>Build 3132</h2>
<div class="release-date">26 May 2017</div>
<ul>
    <li>Added new color schemes Breakers, Mariana and Sixteen, derived from the excellent work of Chris Kempson and Dmitri Voronianski</li>
    <li>Removed legacy color schemes, and moved them into an optional package on Package Control</li>
    <li>Improved the Adaptive theme</li>
    <li>Improved visible whitespace rendering on HiDPI displays</li>
    <li>Linux: Added <a href="https://www.sublimetext.com/docs/3/linux_repositories.html">repositories</a> for apt, yum and pacman</li>
    <li>Various syntax highlighting improvements, including significant improvements for R, with thanks to <a href="https://github.com/randy3k">randy3k</a></li>
    <li>Various regex handling improvements in the Find panel</li>
    <li>Add command equivalents for Find in Files panel</li>
    <li>Mac: Added basic Touch Bar support</li>
    <li>Fixed text widgets cutting off the bottom pixel of their selection border</li>
    <li>Fixed an issue with <tt>close_windows_when_empty</tt> in empty session</li>
    <li>Fix Open Containing Folder on Windows with a folder containing a comma</li>
    <li>Fix multi-cursor pasting when clipboard contains one or more full lines</li>
    <li>Prevent UNC paths from being mangled by edit_settings</li>
    <li>minihtml: Fix a crash from non-existent CSS vars</li>
    <li>Themes: Default to font.size = 11 when theme doesn't specify size</li>
    <li>API: Fixed selector scoring with the &amp; operator</li>
</ul>
</article>

<article>
<h2>Build 3131</h2>
<div class="release-date">22 April 2017</div>
<ul>
    <li>Fix tab dragging crash in 3130</li>
    <li>Fixed a further sidebar corruption issue</li>
    <li>Fixed labels getting clipped incorrectly after changing <tt>theme_font_options</tt></li>
    <li>Windows: Added support for no_antialias font option when using DirectWrite</li>
    <li>Mac: Fixed gray bar on new windows when using the Adaptive theme</li>
</ul>
</article>

<article>
<h2>Build 3130</h2>
<div class="release-date">21 April 2017</div>
<ul>
    <li>Fixed sidebar corruption issue in 3127</li>
    <li>Fixed Reveal in Sidebar regression in 3127</li>
    <li>Added setting <tt>theme_font_options</tt> to control font rendering of UI elements</li>
    <li>Improved auto indent rules for HTML and PHP</li>
    <li>C#: Improved symbol handling</li>
    <li>Markdown: Improved symbol handling</li>
    <li>Mac: Improved handling of themed title bar</li>
    <li>Windows: Improved fallback font handling in UI elements</li>
    <li>Windows: Fixed visual style regression in 3127</li>
</ul>
</article>

<article>
<h2>Build 3129</h2>
<div class="release-date">13 April 2017</div>
<ul>
    <li>Fixed empty sidebar issue introduced in 3127</li>
    <li>Fixed auto complete popup not indicating matching characters</li>
    <li>Mac: Fixed moving windows with custom title bars between retina and non-retina screens</li>
</ul>
</article>

<article>
<h2>Build 3128</h2>
<div class="release-date">12 April 2017</div>
<ul>
    <li>Fixed a gutter icon rendering regression in Windows</li>
    <li>Fixed incorrect auto complete font size in Windows and Linux</li>
    <li>Fixed enter not working in the side bar</li>
    <li>Fixed an output panel crash regression</li>
</ul>
</article>

<article>
<h2>Build 3127</h2>
<div class="release-date">12 April 2017</div>
<ul>
    <li>Refreshed UI theme, including full high DPI support</li>
    <li>New icon</li>
    <li>Added alternate theme, Adaptive, that inherits colors from the color scheme</li>
    <li>Added color scheme and theme switchers with live preview via the command palette</li>
    <li>Support for custom color window title bars on OS X 10.10+</li>
    <li>Many additions and bug fixes to the theme engine, plus <a href="http://www.sublimetext.com/docs/3/themes.html">full documentation</a></li>
    <li>Added touch input on Windows</li>
    <li>Improved font selection on all platforms, allowing selection of different weights by name</li>
    <li>Font geometry issues that prevent bold or italics are now printed in the console</li>
    <li>Windows font rendering defaults to DirectWrite unless using Consolas or Courier New</li>
    <li>OS X 10.11 and macOS 10.12+ default to using San Francisco for the UI font</li>
    <li>High DPI textures are used on Windows and Linux when the DPI scale is greater than 1.0</li>
    <li>All API functions now accept and return device-independent-pixels</li>
    <li>Gutter icons are now sized properly on Windows and Linux high DPI screens</li>
    <li>Improved sidebar performance when folders contain many thousands of files</li>
    <li>Fixed file change notifications from freezing UI on macOS Sierra</li>
    <li>Prevent a crash when a malformed regex is used in indentation settings</li>
    <li>OS X: the user's default shell is executed and environmental variables are set in the plugin Python environment</li>
    <li>minihtml now respects font options from the settings</li>
    <li>minihtml now supports borders</li>
    <li>Improved inline error message style</li>
    <li>Significant improvements to Markdown syntax highlighting, with thanks to <a href="https://github.com/keith-hall">keith-hall</a></li>
    <li>Significant improvements to C# syntax highlighting, with thanks to <a href="https://github.com/gwenzek">gwenzek</a></li>
    <li>Significant improvements to Java syntax highlighting, with thanks to <a href="https://github.com/djspiewak">djspiewak</a></li>
    <li>Significant improvements to Python syntax highlighting, with thanks to <a href="https://github.com/FichteFoll">FichteFoll</a></li>
    <li>Various syntax highlighting improvements</li>
    <li>Various bugs with the syntax highlighting engine have been resolved</li>
    <li>The subl executable on OS X and plugin_host.exe on Windows are now signed</li>
    <li>sublime_text.exe on Windows now has CompanyName set in VERSIONINFO</li>
    <li>API: Updated OpenSSL to 1.0.2k, SQLite to 3.16.02</li>
</ul>
</article>

<article>
<h2>Build 3125</h2>
<div class="release-date">23 September 2016</div>
<ul>
    <li>Added Indexing Status to the Help menu to give more information about what the indexer is doing</li>
    <li>Fixed a compatibility issue with some third party syntax definitions that include <tt>JavaScript.sublime-syntax</tt></li>
    <li>Reduced the default number of worker processes used for indexing. This can be manually controlled via the <tt>index_workers</tt> setting</li>
    <li>API: Updated OpenSSL to 1.0.2i</li>
</ul>
</article>

<article>
<h2>Build 3123</h2>
<div class="release-date">21 September 2016</div>
<ul>
    <li>Minor improvements to file load times</li>
    <li>minihtml: Resolved some HiDPI issues on Windows</li>
    <li>API: on_hover() is now called with the current, rather than primary, view</li>
    <li>API: Added on_hover() and on_query_completions() to ViewEventListener</li>
    <li>API: Modifications to a selection are now constrained to the valid range</li>
</ul>
</article>

<article>
<h2>Build 3122</h2>
<div class="release-date">15 September 2016</div>
<ul>
    <li>OSX: Fixed a crash regression in 3121</li>
</ul>
</article>

<article>
<h2>Build 3121</h2>
<div class="release-date">14 September 2016</div>
<ul>
    <li>Added a menu item to install Package Control</li>
    <li>Various syntax highlighting improvements</li>
    <li>Significant improvements to Scala syntax highlighting, with thanks to <a href="https://github.com/djspiewak">djspiewak</a> and <a href="https://github.com/gwenzek">gwenzek</a></li>
    <li>File encoding of open files is now stored in the session</li>
    <li>Fixed some rendering issues with Phantoms</li>
    <li>Linux and OSX: Improved memory usage</li>
    <li>minihtml: Support HiDPI on Windows and Linux</li>
    <li>minihtml: Improved handling of padding and inline elements with background</li>
    <li>minihtml: Added support for windows style line endings and single quoted attributes</li>
    <li>API: Don't abort loading packages if a .sublime-package is corrupt</li>
    <li>API: Fixed edge case when loading third party packages from unicode paths on Windows</li>
    <li>API: Updated Python 3.3 to commit 8e3b9bf917a7, and SQLite to 3.14.1</li>
</ul>
</article>

<article>
<h2>Build 3120</h2>
<div class="release-date">28 July 2016</div>
<ul>
    <li>Fixed a minihtml crash</li>
</ul>
</article>

<article>
<h2>Build 3119</h2>
<div class="release-date">26 July 2016</div>
<ul>
    <li>Improved inline build error styling</li>
    <li>Improved Goto Definition performance when a large number of files are open</li>
    <li>Phantoms are updated when the color scheme or font size changes</li>
    <li>Significant improvements to LaTeX syntax highlighting, with thanks to <a href="https://github.com/randy3k">randy3k</a></li>
    <li>Various syntax highlighting improvements</li>
    <li>Fixed an issue where clicking with the mouse would sometimes position the selection incorrectly</li>
    <li>minihtml: Added support for padding and backgrounds on inline elements, relative positioning, border-radius, rem units, child selectors and various CSS function calls (color-mod, var, rgb, rgba, hsl and hsla).</li>
    <li>Linux: Improved rendering performance for some systems</li>
</ul>
</article>

<article>
<h2>Build 3118</h2>
<div class="release-date">28 June 2016</div>
<ul>
    <li>Build errors are now shown inline at the location where they occurred. This is controlled with the show_errors_inline setting.</li>
    <li>Show Definitions: Now works for languages embedded in HTML (PHP, ASP, ERB etc)</li>
    <li>Show Definitions: Fixed filtering for unsaved views and on Windows</li>
    <li>Color Schemes: popupCss will be generated automatically if not present</li>
    <li>Build Systems may define a cancel command using the "cancel" key</li>
    <li>Fixed Replace not working as expected in conjunction with regex look behinds</li>
    <li>minihtml: Implemented font-family stacks</li>
    <li>minihtml: Added support for inherit CSS value</li>
    <li>minihtml: Fixed vertical stretching on images</li>
    <li>API: Added Phantoms</li>
    <li>API: Added ViewEventListener</li>
    <li>API: Added View.is_primary()</li>
</ul>
</article>

<article>
<h2>Build 3117</h2>
<div class="release-date">22 June 2016</div>
<ul>
    <li>Fixed a JSON encoding regression in 3116</li>
</ul>
</article>

<article>
<h2>Build 3116</h2>
<div class="release-date">22 June 2016</div>
<ul>
    <li>Settings now open in a new window, with the default and user settings side-by-side</li>
    <li>Hovering over a symbol will show a popup indicating where it's defined. This is controlled with the show_definitions setting.</li>
    <li>Various syntax highlighting improvements</li>
    <li>OSX: Fixed a graphical glitch when switching tabs</li>
    <li>OSX: Fixed crash when entering a surrogate pair via hex input</li>
    <li>Syntax: Added clear_scopes directive, to give more control over the generated scopes</li>
    <li>Color Schemes: Added popupCss key, for defining default popup style sheets</li>
    <li>Fixed build systems being unable to use file_patterns with the exec command</li>
    <li>minihtml: Added line-height CSS property</li>
    <li>minihtml: Fixed a stack overflow on Windows with too many unclosed tags</li>
    <li>API: Added functions to get/set the minimap, status bar, tabs and menu</li>
    <li>API: Added <tt>on_hover(view, point, hover_zone)</tt> event</li>
</ul>
</article>

<article>
<h2>Build 3113</h2>
<div class="release-date">11 May 2016</div>
<ul>
    <li>Various syntax highlighting improvements</li>
    <li>Fixed a crash that could occur with an invalid result_file_regex settings</li>
    <li>API: Updated OpenSSL to 1.0.2h</li>
</ul>
</article>

<article>
<h2>Build 3112</h2>
<div class="release-date">5 May 2016</div>
<ul>
    <li>Various syntax highlighting improvements</li>
    <li>Some snippets have have been moved into a sub-directories, so custom overrides and key bindings that reference them will need to be updated</li>
    <li>Linux: Fixed a regression that caused some graphical glitches</li>
    <li>API: Changes to how plugins are loaded. This should be transparent, but resolves a number of corner cases</li>
</ul>
</article>

<article>
<h2>Build 3111</h2>
<div class="release-date">13 April 2016</div>
<ul>
    <li>Various rendering fixes</li>
    <li>Windows: Disabled layer based rendering due to screen tearing</li>
    <li>Monokai: Fixed incorrect operator highlighting</li>
</ul>
</article>

<article>
<h2>Build 3110</h2>
<div class="release-date">12 April 2016</div>
<ul>
    <li>Improved rendering performance, especially on high resolution screens</li>
    <li>New C++ syntax definition with improved accuracy and performance</li>
    <li>Various other syntax highlighting improvements</li>
    <li>HTML: Pressing enter when between a tag pair will increase indentation</li>
    <li>Improved file indexing behavior with multiple windows open</li>
    <li>API: Added window.status_message</li>
    <li>API: Windows is now up-to-date with the other platforms, using Python 3.3.6 and having the sqlite3 and bz2 modules</li>
</ul>
</article>

<article>
<h2>Build 3109</h2>
<div class="release-date">18 March 2016</div>
<ul>
    <li>Added Rust package</li>
    <li>Improvements to JavaScript syntax highlighting</li>
    <li>Significant improvements to YAML syntax highlighting</li>
    <li>Various other syntax highlighting improvements</li>
    <li>Fixed a scenario where changes to <tt>.tmPreferences</tt> files weren't being picked up</li>
    <li>Improved handling of punctuation in the spell checker</li>
    <li>Package Development: Added 'Syntax Tests - Regex Compatibility' build variant for evaluating syntax definition performance</li>
    <li>Package Development: Expanded the set of regexes the new regex engine is able to handle</li>
    <li>API: Updated to Python 3.3.6, and now includes the _ssl module on Linux, plus sqlite3 and bz2 on all platforms</li>
</ul>
</article>

<article>
<h2>Build 3107</h2>
<div class="release-date">25 February 2016</div>
<ul>
    <li>Further improvements to JavaScript syntax highlighting</li>
    <li>Fixed a theme related regression in 3106 that could cause the tabs to disappear</li>
    <li>Fixed a regression in 3106 that caused file icons to disappear</li>
</ul>
</article>

<article>
<h2>Build 3106</h2>
<div class="release-date">24 February 2016</div>
<ul>
    <li>Significant changes to JavaScript syntax highlighting</li>
    <li>Themes may now be switched on the fly without artifacts</li>
    <li>Syntax Definitions: Fixed some cases where pop matches with back references weren't working correctly</li>
    <li>Fixed a rare spell check crash regression in 3104</li>
</ul>
</article>

<article>
<h2>Build 3105</h2>
<div class="release-date">18 February 2016</div>
<ul>
    <li>Fixed a performance issue with the JavaScript syntax highlighting changes</li>
    <li><tt>show_scope_name</tt> command shows the scope in a popup</li>
</ul>
</article>

<article>
<h2>Build 3104</h2>
<div class="release-date">17 February 2016</div>
<ul>
    <li>JavaScript syntax highlighting improvements</li>
    <li>Various other syntax highlighting improvements to the shipped Packages</li>
    <li>Improved word wrap behavior</li>
    <li>Improved spell check behavior</li>
    <li>Fixed some Unicode handling issues in Goto Anything</li>
    <li>Fixed a 3096 regression in regular expressions when using <tt>\x{nnnn}</tt> escapes</li>
    <li>Fixed a 3096 rendering performance regression</li>
</ul>
</article>

<article>
<h2>Build 3102</h2>
<div class="release-date">8 February 2016</div>
<ul>
    <li>Fixed a 3096 regression in regular expressions when using the <tt>[[:space:]]</tt> character class</li>
    <li>Fixed a 3096 regression Find in Files output with non-ascii text</li>
    <li>Added fallback for themes without the Panel Switcher button</li>
    <li>File change detection better handles failures in the underlying API</li>
</ul>
</article>

<article>
<h2>Build 3101</h2>
<div class="release-date">5 February 2016</div>
<ul>
    <li>Added Panel Switcher to status bar</li>
    <li>Sublime Text is more proactive about polling for file changes, rather than waiting for file system change notifications</li>
    <li>Fixed regression in regular expressions with upper case escape sequences</li>
    <li>Fixed regression in regular expression format strings</li>
    <li>API: Added find_output_panel(), destroy_output_panel(), active_panel() and panels()</li>
    <li>API: Added create_output_panel() now accepts an optional parameter, <tt>"unlisted"</tt></li>
</ul>
</article>

<article>
<h2>Build 3100</h2>
<div class="release-date">3 February 2016</div>
<ul>
    <li>Windows: Updated code signing certificate to no longer use SHA1</li>
    <li>Added "Profile Events" to the Command Palette, to help identify slow plugins</li>
    <li>Incorporates further changes to the provided packages</li>
    <li>Fixed Copy and Paste not working with some Unicode strings</li>
    <li>Fixed Goto Definition command not working when placed in a submenu</li>
    <li>Fixed incorrect handling of <tt>[[:blank:]]</tt> character class in syntax definitions</li>
    <li>Spell Checker: Improved Unicode handling</li>
    <li>Spell Checker: Now reads from manually edited user preferences on the fly</li>
    <li>minihtml: Fixed <tt>text-decoration: none</tt> not being handled correctly</li>
    <li>OSX: Fixed Emoji &amp; Symbols popup failing to insert text in some cases</li>
    <li>Windows: Added support for inserting characters from outside of the BMP</li>
</ul>
</article>

<article>
<h2>Build 3099</h2>
<div class="release-date">29 January 2016</div>
<ul>
    <li>Fixed a code folding crash regression in 3098</li>
</ul>
</article>

<article>
<h2>Build 3098</h2>
<div class="release-date">29 January 2016</div>
<ul>
    <li>Improved Unicode support, including combining character rendering, character classification in regex searches, and case insensitivity in Goto Anything matching</li>
    <li>Updates to many packages, with more substantial changes to D, Go and SQL</li>
    <li>Stability improvements for Find in Files when using regular expressions that result in significant backtracking</li>
    <li>Better handling of troublesome files during indexing</li>
    <li>Fixed file truncation when using hexadecimal encoding</li>
    <li>Syntax: Improvements to the Syntax Tests build system, including a new variant for measuring performance</li>
    <li>Syntax: .sublime-syntax files with unused captures no longer cause spellcheck errors</li>
    <li>Windows: <tt>ctrl+alt+p</tt> is no longer bound by default, due to compatibility issues with some keyboard layouts</li>
    <li>Linux: crash_reporter is statically linked, improving system compatibility</li>
    <li>API: Added Window.is_sidebar_visible() and Window.set_sidebar_visible()</li>
</ul>
</article>

<article>
<h2>Build 3095</h2>
<div class="release-date">10 July 2015</div>
<ul>
    <li>Incorporates further changes to the provided packages</li>
</ul>
</article>

<article>
<h2>Build 3094</h2>
<div class="release-date">2 July 2015</div>
<ul>
    <li>Fixed a regression in 3093 where the Go and Makefile syntax definitions were missing</li>
    <li>Incorporates further changes to the provided packages</li>
</ul>
</article>

<article>
<h2>Build 3093</h2>
<div class="release-date">1 July 2015</div>
<ul>
    <li>Packages are now on <a href="https://github.com/sublimehq/Packages">GitHub</a></li>
    <li>Incorporates several community provided improvements to the above packages, with significant improvements to HTML, CSS and JavaScript</li>
    <li>Fixed an infinite loop that occurred when loading some .sublime-syntax files</li>
</ul>
</article>

<article>
<h2>Build 3092</h2>
<div class="release-date">4 June 2015</div>
<ul>
    <li>Improved handling of third party packages that try to replace the default HTML syntax definition</li>
    <li>Fixed an issue with nested with_prototype statements in .sublime-syntax files</li>
</ul>
</article>

<article>
<h2>Build 3091</h2>
<div class="release-date">2 June 2015</div>
<ul>
    <li>Fixed a regression in 3090 where .tmLanguage files with missing includes weren't loaded</li>
</ul>
</article>

<article>
<h2>Build 3090</h2>
<div class="release-date">2 June 2015</div>
<ul>
    <li>.sublime-syntax files may now include .tmLanguage ones, using "scope:source.foo" to refer to them</li>
    <li>Fixed some inconsistencies in Goto Anything when selecting symbols</li>
</ul>
</article>

<article>
<h2>Build 3088</h2>
<div class="release-date">27 May 2015</div>
<ul>
    <li>Fixed regressions in JavaScript and PHP syntax highlighting</li>
    <li>Syntax: .sublime-syntax files can now specify just the basename of an included file, to enable overriding</li>
    <li>Linux: Fixed a file permission issue when running without --wait</li>
</ul>
</article>

<article>
<h2>Build 3087</h2>
<div class="release-date">26 May 2015</div>
<ul>
    <li>Updated various syntax highlighting definitions</li>
    <li>Syntax: .tmLanguage files may now include .sublime-syntax ones</li>
    <li>Syntax: Fixed scope names not being applied correctly when pushing multiple contexts</li>
    <li>Syntax: .sublime-syntax files may now push a list of anonymous contexts</li>
    <li>Syntax: Anonymous contexts may now be used within <tt>with_prototype</tt> blocks</li>
    <li>Syntax: Fixed variable expansion within included syntax files</li>
    <li>API: Added View.is_auto_complete_visible()</li>
</ul>
</article>

<article>
<h2>Build 3086</h2>
<div class="release-date">12 May 2015</div>
<ul>
    <li>Fixed a code folding and indent guide regression in 3085 when indenting with tabs</li>
    <li>Fixed syntax highlighting regressions in 3085</li>
    <li>Improved the behavior of <tt>convert_syntax.py</tt> on multi line regexs</li>
</ul>
</article>

<article>
<h2>Build 3085</h2>
<div class="release-date">5 May 2015</div>
<ul>
    <li>Sublime Text now includes a custom regex engine that matches multiple regexps in parallel, for faster file loading and indexing</li>
    <li>.sublime-syntax files can now define variables, to help write repetitive patterns</li>
    <li>Improved indenting behavior when <tt>indent_to_bracket</tt> is enabled</li>
    <li>Fixed brackets in strings influencing auto indent</li>
</ul>
</article>

<article>
<h2>Build 3084</h2>
<div class="release-date">8 April 2015</div>
<ul>
    <li>Added new Syntax Definition file format, <a href="http://www.sublimetext.com/docs/3/syntax.html">.sublime-syntax</a></li>
    <li>Added support for testing syntax definitions in either format (details at above link)</li>
    <li>YAML editing improvements</li>
    <li>Build Systems may now define a list of file name wildcard patterns to trigger on, via the <tt>file_patterns</tt> key</li>
    <li><tt>prompt_open_file</tt> and related commands now accept an <tt>initial_directory</tt> argument</li>
    <li>Fixed tab completion regression in 3081, where h1..h6 HTML completions were not triggering</li>
</ul>
</article>

<article>
<h2>Build 3082</h2>
<div class="release-date">26 March 2015</div>
<ul>
    <li>Improved handling of index corruption: index will be automatically recreated</li>
    <li>Fixed squiggly lines not drawing squiggly in tall windows</li>
</ul>
</article>

<article>
<h2>Build 3081</h2>
<div class="release-date">25 March 2015</div>
<ul>
    <li>Improved handling of index corruption: Sublime Text will no longer perform repetitive indexing in this scenario</li>
    <li>Added <tt>index_workers</tt> setting to control the number of threads used for file indexing</li>
    <li>Tab completion no longer completes numbers. <i>Edit/Show Completions</i> can still be used for this</li>
    <li>Fixed Command Palette causing a crash with empty .sublime-build files</li>
</ul>
</article>

<article>
<h2>Build 3079</h2>
<div class="release-date">20 March 2015</div>
<ul>
    <li>Fixed a long standing plugin_host crash triggered via modal dialogs</li>
    <li>Python: Tweaked property snippet to not be so intrusive</li>
</ul>
</article>

<article>
<h2>Build 3078</h2>
<div class="release-date">19 March 2015</div>
<ul>
    <li>Fixed a plugin_host regression in 3077</li>
</ul>
</article>

<article>
<h2>Build 3077</h2>
<div class="release-date">19 March 2015</div>
<ul>
    <li>Fixed a regression in 3075 that caused the default preferences to be marked as unsaved</li>
    <li>Fixed a performance regression with large folders introduced in 3067</li>
    <li>Partially reworked plugin_host communication</li>
    <li>OSX: Fixed a regression in 3076 that caused excess CPU usage</li>
</ul>
</article>

<article>
<h2>Build 3075</h2>
<div class="release-date">10 March 2015</div>
<div class="forum-link">See also the <a href="http://www.sublimetext.com/forum/viewtopic.php?f=2&t=17733">Forum Thread</a></div>
<ul>
    <li>Build Systems: Build systems can now be explicitly selected again</li>
    <li>Build Systems: Renamed "keyfile" to "keyfiles", now accepting a list of files that can trigger the build system (e.g., <tt>["Makefile", "makefile"]</tt>)</li>
    <li>Improved change detection for files that disappear and reappear, as happens with disconnected network drives</li>
    <li>Windows: Added workaround for broken <tt>std::condition_variable</tt> in MSVC 2012, fixing a crash in <tt>plugin_host</tt></li>
    <li>Updated to a never version of leveldb, fixing constant low level CPU usage if the index becomes corrupted</li>
    <li>Fixed a crash that could occur in directory scanning when directories are being rapidly deleted and recreated</li>
    <li>Transient sheets (e.g., as created by Goto Anything when previewing files) are no longer added to the Recently Closed list</li>
    <li>Windows: Added more descriptive errors when the Update Installer fails to rename a folder</li>
</ul>
</article>

<article>
<h2>Build 3074</h2>
<div class="release-date">3 March 2015</div>
<div class="forum-link">See also the <a href="http://www.sublimetext.com/forum/viewtopic.php?f=2&t=17681">Forum Thread</a></div>
<ul>
    <li>Build Systems: Variants can now be selected directly when pressing Primary+B (See <a href="http://www.sublimetext.com/forum/viewtopic.php?f=2&t=17471">this discussion</a> for more information)</li>
    <li>Posix: Fixed new files not respecting the umask permission flags</li>
    <li>OSX: Workaround for an OS issue with zero size windows and OpenGL views</li>
    <li>Windows: Fixed incorrect window sizing after making a maximised window full screen</li>
    <li>Windows: Fixed access denied errors that could occur when saving with <tt>atomic_save</tt> disabled</li>
    <li><tt>remember_open_files</tt> setting is now hidden, and defaults to false. Note that this change will have no effect if the <tt>hot_exit</tt> setting is left at its default value of true</li>
</ul>
</article>

<article>
<h2>Build 3073</h2>
<div class="release-date">28 February 2015</div>
<div class="forum-link">See also the <a href="http://www.sublimetext.com/forum/viewtopic.php?f=2&t=17664">Forum Thread</a></div>
<ul>
    <li>Fixed a Goto Definition regression in 3072</li>
    <li>Build System choices are remembered, so the user will be prompted to choose a build system less often</li>
    <li>Added Edit Project to the Command palette</li>
</ul>
</article>

<article>
<h2>Build 3072</h2>
<div class="release-date">27 February 2015</div>
<div class="forum-link">See also the <a href="http://www.sublimetext.com/forum/viewtopic.php?f=2&t=17658">Forum Thread</a></div>
<ul>
    <li>Changelog is now in HTML</li>
    <li>Reworked how Build Systems are selected (<a href="http://www.sublimetext.com/forum/viewtopic.php?f=2&t=17471">More Information</a>) </li>
    <li>Fixed Redo sometimes restoring the selection to the incorrect location</li>
    <li>Command Palette now remembers the last entered string</li>
    <li><tt>atomic_save</tt> is disabled by default</li>
    <li>Fixed tabset background being set to the wrong color on startup if different colored tabs are used</li>
    <li>Improved scrolling behavior when <tt>line_padding_top</tt> is &gt; 0</li>
    <li>minihtml: Added support for &lt;img&gt; tags, in conjunction with file://, res:// and data: URLs</li>
    <li>minihtml: Added support &lt;ul&gt; and &lt;li&gt; elements</li>
    <li>minihtml: Added support for padding</li>
    <li>minihtml: Added support background-color on inline elements</li>
</ul>
</article>

<article>
<h2>Build 3071</h2>
<div class="release-date">20 February 2015</div>
<div class="forum-link">See also the <a href="http://www.sublimetext.com/forum/viewtopic.php?f=2&t=17610">Forum Thread</a></div>
<ul>
    <li>API: Added COOPERATE_WITH_AUTO_COMPLETE flag for View.show_popup()</li>
    <li>Properly improved behavior of Goto Definition when using multiple panes</li>
    <li>Fixed a bug with scrolling tabs, where a 1 pixel line would occasionally appear underneath them</li>
    <li>minihtml: Added support for trivial tags small, code, em, var, and strong</li>
    <li>minihtml: Fixed units not being assigned correctly when using shorthand notation</li>
    <li>Windows: Popup windows are now able to receive scroll wheel input</li>
    <li>API: Fixed a regression 3070 where Window.show_quick_panel() incorrectly reported the highlighted item</li>
    <li>API: Fixed a crash caused by passing an empty string into View.show_popup()</li>
</ul>
</article>

<article>
<h2>Build 3070</h2>
<div class="release-date">17 February 2015</div>
<ul>
    <li>API: Added View.show_popup() and related functions</li>
    <li>Added auto_complete_cycle setting</li>
    <li>Fixed Minimap refusing to draw on very large windows</li>
    <li>Tweaked handling of syntax definitions and unused captures, resolving an issue with spell checking in Markdown links.</li>
    <li>Improved behavior of Goto Definition when using multiple panes</li>
    <li>Fixed tmLanguages files with the hidden flag set appearing in the Command Palette</li>
    <li>Tweak to quote auto pairing logic</li>
    <li>Tweak to Open URL regex (thanks facelessuser)</li>
    <li>OSX: Added work around for performActionForItemAtIndex: taking an excessively long time in Yosemite. This affected any commands that had a corresponding menu item.</li>
    <li>API: Window.show_quick_panel() will now scroll to the selected item when shown</li>
    <li>API: Window.show_quick_panel() now accepts the flag sublime.KEEP_OPEN_ON_FOCUS_LOST</li>
    <li>API: Fixed on_post_window_command() not getting called</li>
</ul>
</article>

<article>
<h2>Build 3069</h2>
<div class="release-date">4 February 2015</div>
<ul>
    <li>Fixed a crash regression in 3068 when typing in a transient sheet</li>
    <li>Fixed a long standing issue with spell checking and non-ascii characters</li>
    <li>API: Fixed sublime.yes_no_cancel dialog return value on Windows</li>
</ul>
</article>

<article>
<h2>Build 3068</h2>
<div class="release-date">3 February 2015</div>
<ul>
    <li>Added Goto Definition to the context menu</li>
    <li>Added &lt;current file&gt; option to Find in Files</li>
    <li>Added spelling_selector setting, to control what text is checked for misspellings</li>
    <li>Misspelled words can now be added to the dictionary, in addition to being ignored</li>
    <li>Fixed Ignored Words not persisting after exiting</li>
    <li>Improved some error messages when parsing .tmLanguage files</li>
    <li>Improved URL detection in Open URL context menu item (thanks iamntz and facelessuser)</li>
    <li>Fixed incorrect menu mnemonics</li>
    <li>OSX: Added logging when FSEvents API returns failure</li>
    <li>Fixed a crash regression in 3067 triggered by renaming files</li>
    <li>Fixed sidebar icons sometimes being invisible on startup</li>
    <li>API: Added sublime.yes_no_cancel_dialog()</li>
    <li>API: Added sublime.expand_variables()</li>
    <li>API: Added Window.extract_variables()</li>
    <li>API: Added Sheet.view()</li>
</ul>
</article>

<article>
<h2>Build 3067</h2>
<div class="release-date">30 January 2015</div>
<ul>
    <li>Right clicking on a URL will show an 'Open URL' menu item</li>
    <li>Improved Console Panel scrolling behavior</li>
    <li>Linux: Improved sudo save system compatibility</li>
    <li>OSX: subl command line tool no longer uses Distributed Objects, resolving some intermittent failures</li>
    <li>.tmLanguage files may contain a &lt;hidden&gt; element, to indicate they shouldn't be displayed to the user</li>
    <li>Fixed a crash that occurred when dragging rows scrolled out of view in the side bar</li>
    <li>Fixed not being able to click on the selected row of the auto complete popup</li>
    <li>Fixed a typo in the "Save Workspace As" dialog</li>
</ul>
</article>

<article>
<h2>Build 3066</h2>
<div class="release-date">16 October 2014</div>
<ul>
    <li>Linux: Added sudo save</li>
    <li>Windows: subl.exe command line helper accepts wildcards</li>
    <li>Improved handling of build systems that generate lots of output</li>
    <li>Build Systems may now declare a "keyfile" (e.g., 'Makefile' for the Make build system) to better auto detect which build system to use</li>
    <li>When opening a project with a build system, that build system is now selected by default</li>
    <li>New windows now always use the automatic build system, rather than the build system of the last used window</li>
    <li>Goto Anything supports :line:col syntax in addition to :line</li>
</ul>
</article>

<article>
<h2>Build 3064</h2>
<div class="release-date">27 August 2014</div>
<ul>
    <li>Added remember_full_screen setting</li>
    <li>Posix: Fixed a file permission regression in 3063</li>
</ul>
</article>

<article>
<h2>Build 3063</h2>
<div class="release-date">26 August 2014</div>
<ul>
    <li>Improved quote auto pairing logic</li>
    <li>Selected group is now stored in the session</li>
    <li>Fixed a crash triggered by Goto Anything cloning views</li>
    <li>Windows: Added command line helper, subl.exe</li>
    <li>OSX: Added 'New Window' entry to dock menu</li>
    <li>Posix: Using correct permissions for newly created files and folders</li>
</ul>
</article>

<article>
<h2>Build 3062</h2>
<div class="release-date">5 May 2014</div>
<ul>
    <li>Added sidebar icons</li>
    <li>Added sidebar loading indicators</li>
    <li>Sidebar remembers which folders are expanded</li>
    <li>Fixed a crash in plugin_host</li>
</ul>
</article>

<article>
<h2>Build 3061</h2>
<div class="release-date">21 December 2013</div>
<ul>
    <li>API: Updated to Python 3.3.3</li>
    <li>Tweaked window closing behavior when pressing ctrl+w / cmd+w</li>
    <li>Fixed a lockup when transitioning from a blinking to a solid caret</li>
</ul>
</article>

<article>
<h2>Build 3058</h2>
<div class="release-date">12 December 2013</div>
<ul>
    <li>Added index_exclude_patterns setting to control which files get indexed</li>
    <li>Fixed a crash regression in 3057</li>
</ul>
</article>

<article>
<h2>Build 3057</h2>
<div class="release-date">10 December 2013</div>
<ul>
    <li>Added settings caret_extra_top, caret_extra_bottom and caret_extra_width to control the caret size</li>
    <li>Added settings show_encoding and show_line_endings to control what gets shown on the status bar</li>
</ul>
</article>

<article>
<h2>Build 3056</h2>
<div class="release-date">20 November 2013</div>
<ul>
    <li>Transparent images are drawn with a checkerboard background</li>
    <li>Fixed Find in Files not selecting the correct line for already opened files</li>
    <li>Windows: Fixed extraneous .tmp files when saving</li>
    <li>Vintage: Improved behavior of visual line mode with word wrapped lines</li>
</ul>
</article>

<article>
<h2>Build 3055</h2>
<div class="release-date">19 November 2013</div>
<ul>
    <li>Added image preview when opening images</li>
    <li>Encoding and line endings are displayed in the status bar</li>
    <li>Linux: Fixed a menu hiding issue</li>
    <li>Find in Files will no longer block when FIFOs are encountered</li>
</ul>
</article>

<article>
<h2>Build 3054</h2>
<div class="release-date">16 October 2013</div>
<ul>
    <li>Fixed incorrect title bar in new sessions</li>
    <li>Auto complete now works as expected in macros</li>
    <li>Vintage: A block caret is now used</li>
    <li>Linux: Fixed menu hiding not restoring correctly at startup</li>
    <li>Linux: Fixed incorrect underscore display in some menus</li>
</ul>
</article>

<article>
<h2>Build 3053</h2>
<div class="release-date">30 August 2013</div>
<ul>
    <li>Ctrl+Tab ordering is stored in the session</li>
    <li>Fixed an atomic save file permission regression for newly created files</li>
    <li>When the last file is closed, a new transient file is created automatically</li>
    <li>Linux: Added menu hiding</li>
    <li>API: Window.open_file now accepts an optional group parameter</li>
</ul>
</article>

<article>
<h2>Build 3052</h2>
<div class="release-date">23 July 2013</div>
<ul>
    <li>API: Calling Settings.add_on_change() from within a settings change callback won't cause the added callback to be run</li>
    <li>Fixed a crash in 3050</li>
</ul>
</article>

<article>
<h2>Build 3050</h2>
<div class="release-date">22 July 2013</div>
<ul>
    <li>Fixed a crash regression in 3049</li>
    <li>Minor improvements to Python syntax highlighting</li>
</ul>
</article>

<article>
<h2>Build 3049</h2>
<div class="release-date">19 July 2013</div>
<ul>
    <li>Tab scrolling now works with mouse wheels</li>
    <li>Changed tab close behavior: the neighboring tab is now always selected</li>
    <li>Linux: Fixed incorrect handling of double clicks in the Find panel</li>
    <li>Windows: Fixed hidden attribute regression in 3048 when atomic_save is disabled</li>
    <li>Fixed a crash related to tab scrolling</li>
    <li>API: Plugins may now call Settings.clear_on_change() within a callback from Settings.add_on_change()</li>
</ul>
</article>

<article>
<h2>Build 3048</h2>
<div class="release-date">10 July 2013</div>
<ul>
    <li>Added tab scrolling, controlled by the enable_tab_scrolling setting</li>
    <li>Automatically closing windows when the last tab is dragged out</li>
    <li>Added minimap_scroll_to_clicked_text setting</li>
    <li>Improved error messages when unable to save files</li>
    <li>font_options is now case insensitive</li>
    <li>Posix: Fixes new files being created with unexpected permissions</li>
    <li>Windows: SSE support is no longer required for 32 bit builds</li>
</ul>
</article>

<article>
<h2>Build 3046</h2>
<div class="release-date">26 June 2013</div>
<ul>
    <li>API: Supporting a distinction between Python modules and packages, to ensure relative imports work as expected</li>
</ul>
</article>

<article>
<h2>Build 3045</h2>
<div class="release-date">25 June 2013</div>
<ul>
    <li>Windows: Fixed plugin overriding</li>
</ul>
</article>

<article>
<h2>Build 3044</h2>
<div class="release-date">24 June 2013</div>
<ul>
    <li>Improved handling of Python sub-package importing, fixing the delete from side bar regression</li>
</ul>
</article>

<article>
<h2>Build 3043</h2>
<div class="release-date">21 June 2013</div>
<ul>
    <li>Deleted files are marked as dirty again</li>
    <li>Fixed a regression when overriding the color scheme in syntax specific settings</li>
    <li>Linux and OSX: atomic_save is adaptively disabled when it's not possible to preserve file permissions</li>
    <li>API: Fixed settings objects getting invalidated too early with cloned views</li>
    <li>API: Plugins in zip files are able to be overridden via files on disk</li>
</ul>
</article>

<article>
<h2>Build 3041</h2>
<div class="release-date">14 June 2013</div>
<ul>
    <li>Fixed file change detection regression in 3040</li>
    <li>Windows: Fixed a crash introduced in 3034</li>
</ul>
</article>

<article>
<h2>Build 3040</h2>
<div class="release-date">13 June 2013</div>
<ul>
    <li>Fixed a crash on exit that could occur when hot_exit is disabled</li>
    <li>Fixed a crash introduced in 3036</li>
    <li>Windows: DirectWrite support uses the old path when drawing from a the text buffer</li>
    <li>Windows: Auto updater supports updating from unicode paths</li>
    <li>API: Added support for the termios module on Linux and OS X.</li>
</ul>
</article>

<article>
<h2>Build 3038</h2>
<div class="release-date">9 June 2013</div>
<ul>
    <li>Fixed further regressions in 3036</li>
</ul>
</article>

<article>
<h2>Build 3037</h2>
<div class="release-date">4 June 2013</div>
<ul>
    <li>Fixed a regression in 3036</li>
</ul>
</article>

<article>
<h2>Build 3036</h2>
<div class="release-date">4 June 2013</div>
<ul>
    <li>Fixed regressions in file change detection</li>
    <li>Linux: Added support for High DPI, controlled by the GTK Text Scaling Factor</li>
    <li>Windows: DirectWrite is enabled automatically in high DPI mode</li>
    <li>OSX: Fixed context menus not working when the application is in the background</li>
</ul>
</article>

<article>
<h2>Build 3035</h2>
<div class="release-date">17 May 2013</div>
<ul>
    <li>Restored Windows XP compatibility</li>
    <li>Fixed an OSX crash</li>
    <li>Fixed double closing of script tags</li>
</ul>
</article>

<article>
<h2>Build 3034</h2>
<div class="release-date">16 May 2013</div>
<ul>
    <li>Improved file change detection</li>
    <li>Windows: Added high DPI support</li>
    <li>Graphics rendering ported to Skia from Cairo</li>
    <li>HTML tag auto completion is better behaved in script tags</li>
    <li>API: Fixed Selection.contains</li>
</ul>
</article>

<article>
<h2>Build 3032</h2>
<div class="release-date">6 May 2013</div>
<ul>
    <li>Added setting always_prompt_for_file_reload</li>
    <li>Pressing right in the Goto Anything overlay will open the selected file without closing the overlay</li>
    <li>Improved handling of deleted files when restoring sessions</li>
    <li>Linux: Fixed popup menu positioning</li>
    <li>Windows: Fixed erroneous entries in system menu</li>
</ul>
</article>

<article>
<h2>Build 3031</h2>
<div class="release-date">1 May 2013</div>
<ul>
    <li>Find panel has a drop down arrow to select previous items</li>
    <li>Minor Auto Complete visual tweaks</li>
    <li>API: Added view.show_popup_menu()</li>
    <li>API: Added is_valid() method to view and window, to determine if the handle has been invalidated</li>
</ul>
</article>

<article>
<h2>Build 3030</h2>
<div class="release-date">23 April 2013</div>
<ul>
    <li>Fixed crash introduced in 3029</li>
</ul>
</article>

<article>
<h2>Build 3029</h2>
<div class="release-date">22 April 2013</div>
<ul>
    <li>Fix for rare crash</li>
    <li>Telemetry is enabled by default for dev builds</li>
    <li>Improved Minimap hover logic</li>
    <li>Faster startup time</li>
</ul>
</article>

<article>
<h2>Build 3028</h2>
<div class="release-date">16 April 2013</div>
<ul>
    <li>Fixed a regression in 3027</li>
</ul>
</article>

<article>
<h2>Build 3027</h2>
<div class="release-date">15 April 2013</div>
<ul>
    <li>Fixed several rare crashes</li>
    <li>Improved HTML completions when typing outside of tags</li>
    <li>Fixed Close Tag not respecting self closing tags</li>
    <li>Windows: Fixed auto updates not installing when the application is installed to a drive other than C</li>
</ul>
</article>

<article>
<h2>Build 3026</h2>
<div class="release-date">10 April 2013</div>
<ul>
    <li>auto_find_in_selection defaults to false as intended</li>
    <li>Fixed a sidebar regression in 3024</li>
    <li>Windows: Fixed an 'Open in Sublime Text' regression introduced in 3024</li>
    <li>Improved handling of packages with non-utf8 encoded .py files</li>
</ul>
</article>

<article>
<h2>Build 3025</h2>
<div class="release-date">9 April 2013</div>
<ul>
    <li>Fixed some regressions in 3024</li>
    <li>Added Paste from History</li>
    <li>API: on_text_command and on_window command are now called when the menu is used</li>
    <li>API: Added on_post_text_command and on_post_window_command</li>
</ul>
</article>

<article>
<h2>Build 3024</h2>
<div class="release-date">8 April 2013</div>
<ul>
    <li>Semi-transient sheets are no longer shown in the OPEN FILES section of the side bar</li>
    <li>Added setting 'auto_find_in_selection', for S2 style Find in Selection logic</li>
    <li>Using Google Breakpad to automatically report crashes</li>
    <li>Symlinks are followed by default in folders added to the side bar</li>
    <li>PHP: Improved auto indenting for the alternative control syntax</li>
    <li>"Remove all Folders from Project" now prompts to confirm</li>
    <li>Deleting a file via the side bar will first close the corresponding view, if any</li>
    <li>Update window will display properly even if the theme doesn't have rules for it</li>
    <li>Windows: New style Open Folder dialogs are used on Vista and later</li>
    <li>API: Added view.close()</li>
    <li>API: Added sublime.get_macro()</li>
</ul>
</article>

<article>
<h2>Build 3023</h2>
<div class="release-date">3 April 2013</div>
<ul>
    <li>New auto update system for Windows and OS X</li>
    <li>Added telemetry. Telemetry is currently disabled by default, but will be enabled by default in future dev builds. It can be explicitly controlled with the enable_telemetry setting</li>
    <li>API: Fixed a memory leak in plugin_host</li>
</ul>
</article>

<article>
<h2>Build 3022</h2>
<div class="release-date">18 March 2013</div>
<ul>
    <li>Updated syntax highlighting for PHP, Haskell and Pascal</li>
    <li>API: view.command_history(0, True) now returns the last modifying command, as expected</li>
    <li>API: view.substr(point) now has the same semantics as S2 for out of bounds addresses</li>
    <li>API: Improved communication speed with plugin_host</li>
</ul>
</article>

<article>
<h2>Build 3020</h2>
<div class="release-date">13 March 2013</div>
<ul>
    <li>Linux: Fixed atomic_save working incorrectly with symlinks</li>
    <li>Windows: Fixed a crash under Windows 7 x64</li>
</ul>
</article>

<article>
<h2>Build 3018</h2>
<div class="release-date">11 March 2013</div>
<ul>
    <li>CSS: Completions will not be offered when typing in selectors</li>
    <li>Fixed a scenario where close tag gave incorrect results</li>
    <li>Fixed crash that could occur when dragging a tab associated with a file that needs to be reloaded</li>
    <li>Windows: Fixed shared memory race condition</li>
</ul>
</article>

<article>
<h2>Build 3017</h2>
<div class="release-date">7 March 2013</div>
<ul>
    <li>Further word navigation tweaks</li>
    <li>HTML: Close Tag now works with script and style elements</li>
    <li>HTML: Reindent has been reenabled</li>
    <li>PHP: Fixed typing delay</li>
</ul>
</article>

<article>
<h2>Build 3016</h2>
<div class="release-date">6 March 2013</div>
<ul>
    <li>Smarter word navigation</li>
    <li>HTML: Tags are closed when &lt;/ is entered. This is controlled by the auto_close_tags setting</li>
    <li>HTML: Added attribute completion</li>
    <li>Find and Replace panels automatically resize when multi line strings are entered</li>
    <li>Fixed files being created with the hidden attriute on Windows XP when atomic_save is enabled</li>
    <li>Linux: Using the correct version number for the deb files</li>
</ul>
</article>

<article>
<h2>Build 3015</h2>
<div class="release-date">4 March 2013</div>
<ul>
    <li>Fixed various regressions in 3014</li>
    <li>OSX: Jump Back is now bound to control+hypen</li>
    <li>Improved handling of files with extremely long lines</li>
</ul>
</article>

<article>
<h2>Build 3014</h2>
<div class="release-date">28 February 2013</div>
<ul>
    <li>Added Jump Back and Jump Forward commands</li>
    <li>Improved HTML completions</li>
    <li>Improved HTML auto indent</li>
    <li>Minimap view rectangle auto hides (controlled by the always_show_minimap_viewport setting)</li>
    <li>Updated C# package</li>
    <li>Added invert_selection command</li>
    <li>atomic_save is enabled by default</li>
    <li>Indexing: Added detection of stuck workers</li>
    <li>OSX: Improved handling of line numbers sent via apple events</li>
    <li>API: view.add_regions() will accept package relative paths for the icon</li>
    <li>API: view.add_regions() can show underlines</li>
    <li>API: Added on_pre_close() callback</li>
    <li>API: view.window() will now work even if the view isn't frontmost</li>
</ul>
</article>

<article>
<h2>Build 3013</h2>
<div class="release-date">21 February 2013</div>
<ul>
    <li>Faster loading of large, plain text files</li>
    <li>Improved console scrolling performance on high resolution displays</li>
    <li>Further protection against degenerate syntax definitions</li>
    <li>Added atomic_save setting</li>
    <li>Fixed Reveal in Side Bar</li>
    <li>Fixed C++ syntax highlighting for nested class forward declarations</li>
    <li>Exec panel scrolls again</li>
    <li>Windows: ok_cancel_dialog uses new visual styles</li>
    <li>OSX: Added experimental support for line numbers in the ODB protocol</li>
    <li>API: Added on_text_command() and on_window_command()</li>
    <li>API: Added load_resource(), load_binary_resource() and find_resources()</li>
    <li>API: Added encode_value() and decode_value()</li>
    <li>API: view.sel() supports negative indices</li>
    <li>API: Implemented settings.add_on_change() and settings.clear_on_change()</li>
</ul>
</article>
